#
/*
 *    viterbi.h  --  Viterbi decoder
 *
 */
#ifndef _VITERBI_DECODER_H
#define _VITERBI_DECODER_H
#include	<stdio.h>
#include	<string.h>
#include	<limits.h>
#include	<stdint.h>

//
//	experimental setting for 1/4 7 decoder
class viterbi_2 {
public:
		viterbi_2			(int16_t);
		~viterbi_2 		(void);

	void	deconvolve		(int16_t *, uint8_t *);
private:
	int16_t	costsFor		(uint16_t, int16_t *);
//	int16_t	costsFor		(uint16_t, uint8_t, int16_t *);
	uint8_t	bitFor			(uint16_t, uint16_t, uint8_t);
	int16_t	Poly1;
	int16_t	Poly2;
	int16_t	Poly3;
	int16_t	Poly4;
	int32_t	**transCosts;
	int16_t	**history;
	int16_t	*sequence;
	uint8_t	*poly1_table;
	uint8_t	*poly2_table;
	uint8_t	*poly3_table;
	uint8_t	*poly4_table;
	uint8_t	*table5;
	int16_t	blockLength;
};
#endif
