#
/*
 */
#include	"phasetable.h" 

#define	TABLE_SIZE	1536

	phaseTable::phaseTable (void) {
}

	phaseTable::~phaseTable (void) {
}

struct h {
	int32_t	kmin, kmax;
	int32_t i;
	int32_t n;
};

static struct h myTable [] = {
	{-768, -737, 0, 1},
	{-736, -705, 1, 2},
	{-704, -673, 2, 0},
	{-672, -641, 3, 1},
	{-640, -609, 0, 3},
	{-608, -577, 1, 2},
	{-576, -545, 2, 2},
	{-544, -513, 3, 3},
	{-512, -481, 0, 2},
	{-480, -449, 1, 1},
	{-448, -417, 2, 2},
	{-416, -385, 3, 3},
	{-384, -353, 0, 1},
	{-352, -321, 1, 2},
	{-320, -289, 2, 3},
	{-288, -257, 3, 3},
	{-256, -225, 0, 2},
	{-224, -193, 1, 2},
	{-192, -161, 2, 2},
	{-160, -129, 3, 1},
	{-128,  -97, 0, 1},
	{-96,   -65, 1, 3},
	{-64,   -33, 2, 1},
	{-32,    -1, 3, 2},
	{  1,    32, 0, 3},
	{ 33,    64, 3, 1},
	{ 65,    96, 2, 1},
	{ 97,   128, 2, 1},
	{ 129,  160, 0, 2},
	{ 161,  192, 3, 2},
	{ 193,  224, 2, 1},
	{ 225,  256, 1, 0},
	{ 257,  288, 0, 2},
	{ 289,  320, 3, 2},
	{ 321,  352, 2, 3},
	{ 353,  384, 1, 3},
	{ 385,  416, 0, 0},
	{ 417,  448, 3, 2},
	{ 449,  480, 2, 1},
	{ 481,  512, 1, 3},
	{ 513,  544, 0, 3},
	{ 545,  576, 3, 3},
	{ 577,  608, 2, 3},
	{ 609,  640, 1, 0},
	{ 641,  672, 0, 3},
	{ 673,  704, 3, 0},
	{ 705,  736, 2, 1},
	{ 737,  768, 1, 1}
};

static
const int8_t h0 []   = {0, 2, 0, 0, 0, 0, 1, 1, 2, 0, 0, 0, 2, 2, 1, 1,
	                0, 2, 0, 0, 0, 0, 1, 1, 2, 0, 0, 0, 2, 2, 1, 1};
static
const int8_t h1 []   = {0, 3, 2, 3, 0, 1, 3, 0, 2, 1, 2, 3, 2, 3, 3, 0,
	                0, 3, 2, 3, 0, 1, 3, 0, 2, 1, 2, 3, 2, 3, 3, 0};
static
const int8_t h2 []   = {0, 0, 0, 2, 0, 2, 1, 3, 2, 2, 0, 2, 2, 0, 1, 3,
	                0, 0, 0, 2, 0, 2, 1, 3, 2, 2, 0, 2, 2, 0, 1, 3};
static
const int8_t h3 []   = {0, 1, 2, 1, 0, 3, 3, 2, 2, 3, 2, 1, 2, 1, 3, 2,
	                0, 1, 2, 1, 0, 3, 3, 2, 2, 3, 2, 1, 2, 1, 3, 2};

int32_t		phaseTable::h_table (int32_t i, int32_t j) {
	switch (i) {
	   case 0:
	      return h0 [j];
	   case 1:
	      return h1 [j];
	   case 2:
	      return h2 [j];
	   default:
	   case 3:
	      return h3 [j];
	}
}

DSPFLOAT	phaseTable::get_Phi (int32_t k) {
int32_t k_prime, i, j, n = 0;

	for (j = 0; j < 48; j ++) {
	   if ((myTable [j]. kmin <= k) && (k <= myTable [j]. kmax)) {
	      k_prime = myTable [j]. kmin;
	      i       = myTable [j]. i;
	      n	      = myTable [j]. n;
	      return M_PI / 2 * (h_table (i, k - k_prime) + n);
	   }
	}
	fprintf (stderr, "Help with %d\n", k);
	return 0;
}

