#
/*
 *
 *    Copyright (C)  2010, 2011, 2012
 *    Jan van Katwijk (J.vanKatwijk@gmail.com)
 *    JFF Consultancy
 *
 *    This file is part of the JFF SDR (JSDR).
 *    Many of the ideas as implemented in JSDR are derived from
 *    other work, made available through the GNU general Public License. 
 *    All copyrights of the original authors are recognized.
 *
 *    JSDR is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    JSDR is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with JSDR; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ifndef	FM_CONSTANTS
#define	FM_CONSTANTS

#include	"jff-include.h"

#define	MISERY		"/tmp/misery"
#define	BASE		getenv ("HOME")
#define	DEFAULT_INI	".jsdr-fm-dab.ini"

#define	DABRATE		1920000
#define	RATE_IN		192000
#define	RATE_OUT	48000
#define	ALTERNATIVE_RATE_OUT	RATE_IN
//	for gui.cpp we define
#ifdef __MINGW32__
#define	REPEAT_RATE		8
#define	SPECTRUMSIZE		8192
#define	DISPLAYSIZE		1024
#define	RASTER			50
#else
#define	REPEAT_RATE		9
#define	SPECTRUMSIZE		4096
#define	DISPLAYSIZE		1024
#define	RASTER			50
#endif

#define	MSECFORTIMER	10
//
//	defined in Khz
#define	MIN_LOOP_FREQUENCY	86500
#define	MAX_LOOP_FREQUENCY	108000

//	for fm_processor.cpp we define
#ifdef __MINGW32__
#define	PREFILTER_SIZE		19
#define	PILOTFILTER_SIZE	39
#define	RDSLOWPASS_SIZE		89
#define	HILBERT_SIZE		13
#define	RDSBANDFILTER_SIZE	49
#define	FFT_SIZE		512
#define	PILOT_WIDTH		1000
#define	RDS_WIDTH		1500
#define	LEVEL_SIZE		512
#define	LEVEL_FREQ		3
#else
#define	PREFILTER_SIZE		39
#define	PILOTFILTER_SIZE	39
#define	RDSLOWPASS_SIZE		89
#define	HILBERT_SIZE		13
#define	RDSBANDFILTER_SIZE	49
#define	FFT_SIZE		512
#define	PILOT_WIDTH		1000
#define	RDS_WIDTH		1500
#define	LEVEL_SIZE		512
#define	LEVEL_FREQ		3
#endif

#endif

