#
/*
 * We have to create a simple virtual class here, since we
 * want the interface with both the real device and the generator
 * to be transparent
 */
#ifndef	__VIRTUALINPUT
#define	__VIRTUALINPUT

#include	<stdint.h>
#include	"jff-include.h"

#define	NIX		0100
#define	GENERATOR	0101
#define	STICK		0102
#define	FILEREADER	0103

class	virtualInput {
public:
			virtualInput 	(void);
virtual			~virtualInput 	(void);
virtual		void	setVFOFrequency	(int32_t);
virtual		void	getVFOFrequency	(int32_t *);
virtual		int32_t	setExternalRate	(int32_t);
virtual		int32_t	setExternalGain	(int32_t);
virtual		uint8_t	myIdentity	(void);
		bool	legalFrequency	(int32_t) {return true;}
		int32_t	defaultFrequency	(void) {return 100000000;}
virtual		void	setOffset	(int32_t);

virtual		bool	restartReader	(void);
virtual		void	stopReader	(void);
virtual		int32_t	getSamples	(uint8_t *, int32_t);
virtual		int32_t	getSamples	(uint8_t *, int32_t, int32_t);
virtual		int32_t	Samples		(void);
virtual		int32_t	getSamplesMissed	(void);
virtual		void	resetBuffer	(void);
	        int32_t	vfoOffset;
private:
		int32_t	lastFrequency;
};
#endif

