#ifndef	SPECTROGRAM
#define	SPECTROGRAM

#include	<stdio.h>
#include	<stdlib.h>

class	SpectrogramData: public QwtRasterData {
public:
	double	*data;		// pointer to actual data
	int	left;		// index of left most element in raster
	int	width;		// raster width
	int	height;		// rasterheigth
	int	datawidth;	// width of matrix
	int	dataheight;	// for now == rasterheigth
	double	max;

	SpectrogramData (double *data, int left, int width, int height,
	                 int datawidth, double max):
        QwtRasterData (QwtDoubleRect((double)left, 0.0,
	                                     (double)width - 1, height - 1)) {
	this	-> left		= left;
	this	-> width	= width;
	this	-> data		= data;
	this	-> max		= max;
	this	-> height	= height;
	this	-> datawidth	= datawidth;
	this	-> dataheight	= height;
}

	~SpectrogramData () {
}

double value (double x, double y) const {
	   x = x - left;
	   x = x / width * datawidth;
	   return data [(int)y * datawidth + (int)x];
}

virtual QwtRasterData *copy() const {
        return new SpectrogramData (data, left, width, height, datawidth, max);
}

virtual QwtDoubleInterval range() const {
        return QwtDoubleInterval (0.0, max);
}

};

#endif

