#
/*
 *
 *    Copyright (C) 2008, 2009, 2010
 *    Jan van Katwijk (J.vanKatwijk@gmail.com)
 *    JFF Consultancy
 *
 *    This file is part of the JFF SDR (JSDR).
 *    Many of the ideas as implemented in JSDR are derived from
 *    other work, made available through the GNU general Public License. 
 *    All copyrights of the original authors are recognized.
 *
 *    JSDR is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    JSDR is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with ESDR; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ifndef _DECIMATOR
#define _DECIMATOR

#include	<stdlib.h>
#include	<math.h>
#include	"jff-include.h"
#include	"iir-filters.h"
#include	"fir-filters.h"
/*
 */
class virtualDecimator {
public:
		virtualDecimator ();
	virtual	~virtualDecimator	(void);
virtual	bool	doDecimate	(DSPCOMPLEX, DSPCOMPLEX *);
virtual bool	doDecimate	(DSPFLOAT, DSPFLOAT *);
};

class	IDecimator: public virtualDecimator {
public:
		IDecimator	(int32_t, int32_t);
		~IDecimator 	(void);
	bool	doDecimate	(DSPCOMPLEX, DSPCOMPLEX *);
	bool	doDecimate	(DSPFLOAT, DSPFLOAT *);
private:
	int32_t	intRatio;
	int32_t	intCount;
};

class	EDecimator: public virtualDecimator {
public:
		EDecimator	(int, int);
		~EDecimator	(void);
	bool	doDecimate	(DSPCOMPLEX, DSPCOMPLEX *);
	bool	doDecimate	(DSPFLOAT, DSPFLOAT *);
};

class	FDecimator: public virtualDecimator {
public:
		FDecimator (int32_t, int32_t);
		~FDecimator	(void);
	bool	doDecimate	(DSPCOMPLEX, DSPCOMPLEX *);
	bool	doDecimate	(DSPFLOAT, DSPFLOAT *);

private:
	int64_t		inperiod;
	int64_t		outperiod;
	int64_t		oldinsampleTime;
	int64_t		currentinsampleTime;
	DSPCOMPLEX	oldinsampleValue;
	DSPCOMPLEX	currentinsampleValue;
	DSPCOMPLEX	decimatingSum;
	double		normalizer;
	int64_t		newoutTime;
	LowPassIIR	*LPFilter;
	int32_t		cycleCount;
	int32_t		inSamplerate;
	int32_t		outSamplerate;
};

class	downDecimator {
public:
		downDecimator	(int32_t, int32_t);
		~downDecimator	(void);
	bool	doDecimate	(DSPCOMPLEX, DSPCOMPLEX *);
	bool	doDecimate	(DSPFLOAT, DSPFLOAT *);
private:
	virtualDecimator	*theWorker;
};

#endif

