#
/*
 *
 *    Copyright (C) 2008, 2009, 2010
 *    Jan van Katwijk (J.vanKatwijk@gmail.com)
 *    JFF Consultancy
 *
 *    This file is part of the JFF SDR (JSDR).
 *    Many of the ideas as implemented in JSDR are derived from
 *    other work, made available through the GNU general Public License. 
 *    All copyrights of the original authors are recognized.
 *
 *    JSDR is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    JSDR is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with JSDR; if not, write to the Free Software
 *    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
#ifndef	__PLL_RH
#define	__PLL_RH
/*
 *	This pll was found to give reasonable results.
 *	source DTTSP, all rights acknowledged
 */

#include	"jff-include.h"
#include	"sincos.h"

class	pllR {
private:
	DSPFLOAT	omega;
	DSPFLOAT	NcoPhase;
	DSPFLOAT	NcoPhaseIncr;
	DSPFLOAT	NcoHLimit;
	DSPFLOAT	NcoLLimit;
	DSPFLOAT	freq_f;
	DSPFLOAT	pll_Alpha;
	DSPFLOAT	pll_Beta;
	DSPCOMPLEX	pll_Delay;
	SinCos		*mySinCos;
	DSPFLOAT	phzError;
	DSPFLOAT	oldNcoSignal;
	DSPFLOAT	pll_lock;
public:
			pllR (int32_t	rate,
	                      DSPFLOAT freq,
	                      DSPFLOAT lofreq, DSPFLOAT hifreq,
	                      DSPFLOAT bandwidth, SinCos *Tab = NULL);
		        ~pllR (void);

	void		do_pll		(DSPFLOAT signal);
	DSPFLOAT	getPhaseIncr	(void);
	DSPFLOAT	getNco		(void);
	DSPFLOAT	getPhaseError	(void);
	bool		isLocked	(void);
};

#endif

